<template>
  <div
    role="button"
    class="action btn">
    <template v-if="auth === null">
      <v-popover
        trigger="click"
        :popover-base-class="popoverBaseClass">
        <a
          href="#"
          :class="linkClass"
          @click.prevent="$ga('Price','Click14'); $ym('add_spare_part')">
          + Добавить запчасти
        </a>
        <template slot="popover">
          <div class="text">Доступно только авторизованным</div>
          <a
            class="link-login"
            href="#"
            @click.prevent="showAuthModal(); $ym('add_spare_part_popup_enter')"
            v-close-popover>Войти</a>
          <flink
            class="link-reg"
            href="/users/register"
            domain="main"
            @click.native="$ym('add_spare_part_popup_register')"
            rel="nofollow">Зарегистрироваться</flink>
        </template>
      </v-popover>
    </template>

    <template v-else>
      <flink
        :href="auth.isOrganization ? '/cabinet/price-upload/upload' : '/cabinet/warehouse/do-parts'"
        domain="main"
        :class="linkClass"
        v-if="!blocked"
        @click.native="$ga('Price','Click14');$ym('add_spare_part')">
        + Добавить запчасти
      </flink>

      <v-popover
        v-else
        trigger="click"
        :popover-base-class="popoverBaseClass">
        <a
          href="#"
          :class="linkClass"
          @click.prevent="$ga('Price','Click14');$ym('add_spare_part')">
          + Добавить запчасти
        </a>
        <template slot="popover">
          <template v-if="!auth.isCompleteProfile">
            <div>Необходимо заполнить профиль</div>
            <flink
              rel="nofollow"
              domain="main"
              href="/cabinet/wrench/profile">Перейти к заполнению</flink>
          </template>
          <template v-else-if="auth.isOrganization">
            <template v-if="!auth.organizationSended">
              <div>Необходимо заполнить данные организации</div>
              <flink
                rel="nofollow"
                domain="main"
                href="/cabinet/wrench/organization-info">Перейти к заполнению</flink>
            </template>
            <template v-else-if="!auth.isOrganizationWithShop">
              <div>Необходимо добавить магазин</div>
              <flink
                rel="nofollow"
                domain="main"
                href="/cabinet/wrench/organization-sto/shop/create/">Перейти к добавлению</flink>
            </template>
          </template>
        </template>
      </v-popover>
    </template>
  </div>
</template>

<script>
import { createNamespacedHelpers } from 'vuex';
import { SHOW_AUTH_MODAL } from '~/assets/js/store/actionManager/mutation-types';

const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');
const STORE_USER = createNamespacedHelpers('user');

export default {
  props: {
    colored: {
      type: Boolean,
      default: false,
    },
    coloredClass: {
      type: String,
      default: '',
    },
    popoverBaseClass: {
      type: String,
      default: '',
    },
  },
  computed: {
    ...STORE_USER.mapState(['auth']),
    linkClass() {
      return this.colored ? this.coloredClass : '';
    },
    blocked() {
      return !this.auth.isCompleteProfile
        || (this.auth.isOrganization && (!this.auth.organizationSended || !this.auth.isOrganizationWithShop));
    },
  },
  methods: {
    ...STORE_ACTION_MANAGER.mapMutations({
      showAuthModal: SHOW_AUTH_MODAL,
    }),
  },
};
</script>

<style lang="scss" scoped>

  .kit.main.header {
    a:not(.button) {
      color: currentColor;
    }

    .actions.block {
      > .actions {
        > .action {
          .ui.button {
            font: inherit !important;
            margin: 0.5rem 0;
          }

        }
      }
    }
    &.index {
      @media only screen and (min-width: 1025px) {
        .actions.block .ui.button {
          padding: 0;
          margin: 0;
          background: transparent;
          color: inherit;
        }
      }
      .actions.block {
        @media only screen and (max-width: 1024px) {
          .action.btn {
            display: none;
          }
        }
      }
    }
    &.fixed:not(.index) {
      > .actions.block > .actions > .action.btn .ui.button {
        display: none;
      }
    }
  }
</style>
